declare module 'Cpp'{
    namespace Cpp {
        interface Payment{
            /**
             * Success status of the payment transaction
             */
            success: boolean;

            /**
             * 
             */
            txn?: Payment.Txn | null;
        }

        namespace Payment{
            interface Txn{
                /**
                 * 
                 */
                txnId: string;

                /**
                 * 
                 */
                authorized: boolean;

                /**
                 * 
                 */
                resultCode: string;

                /**
                 * 
                 */
                resultText: string;

                /**
                 * 
                 */
                authorizationCode: string;

                /**
                 * 
                 */
                txnTimestamp: string;

                /**
                 * 
                 */
                 paymentMethod: PaymentMethod.Details

                 /**
                  * 
                  */
                 card?: Card | null
            }

            interface card{
                /**
                 * 
                 */
                cardHolderName: string;

                /**
                 * 
                 */
                maskedCardNumber: string;

                /**
                 * 
                 */
                expiryMonth: string;

                /**
                 * 
                 */
                expiryYear: string;

                /**
                 * 
                 */
                cardType: string;

                /**
                 * 
                 */
                cardToken: string;

                /**
                 * 
                 */
                cardId: string;
            }
        }

        interface PaymentCreateParams {
            /**
             * Payment method id returned from Get Customer Payment Method(s) request.
             */
            token: string;
      
            /**
             * Customer id generated from the Create Customer request.
             */
            customerId?: string;

            /**
             * Transaction reference set by API caller
             */
            clientRef?: string;

            /**
             * Transaction types include: purchase, auth, validate
             */
            txnType: string;

            /**
             * ISO 4217 3 letter currency code
             */
            currencyCode: string;

            /**
             * Amount for payment
             */
            totalAmount: string;
        }

        class PaymentsResource {
            /**
             * Creates a new payment object.
             */
            create(
              params?: PaymentCreateParams,
              options?: RequestOptions
            ): Promise<Cpp.Response<Cpp.Payment>>;
            create(
              options?: RequestOptions
            ): Promise<Cpp.Response<Cpp.Payment>>;
        }
    }
}